﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Windows.Threading;
using System.Diagnostics;

namespace FullScreenChangedSample
{
    public partial class Page : UserControl
    {
        /// <summary>
        /// ActualWidth를 출력하는 타이머
        /// </summary>
        DispatcherTimer _timer = new DispatcherTimer();

        public Page()
        {
            InitializeComponent();

            // 타이머 설정
            _timer.Interval = TimeSpan.FromMilliseconds(50);
            _timer.Tick += new EventHandler(_timer_Tick);
            _timer.Start();

            // 전체화면 변경 이벤트
            Application.Current.Host.Content.FullScreenChanged += new EventHandler(Content_FullScreenChanged);
        }

        void Content_FullScreenChanged(object sender, EventArgs e)
        {
            string temp = string.Format("[IsFullScreen = {0}]", Application.Current.Host.Content.IsFullScreen);
            Output(temp);
        }

        void _timer_Tick(object sender, EventArgs e)
        {
            string temp = string.Format("ScrollViewer = {0}, LayoutRoot = {1}, Content = {2}", svOutput.ActualWidth, LayoutRoot.ActualWidth, Application.Current.Host.Content.ActualWidth);
            Output(temp);
        }

        private void Output(object output)
        {
            (svOutput.Content as TextBox).Text += output.ToString() + "\n";

            svOutput.ScrollToVerticalOffset(svOutput.ScrollableHeight);
        }

        private void buttonStopTimer_Click(object sender, RoutedEventArgs e)
        {
            _timer.Stop();
        }

        private void buttonFullScreenToggle_Click(object sender, RoutedEventArgs e)
        {
            Application.Current.Host.Content.IsFullScreen = !Application.Current.Host.Content.IsFullScreen;
        }
    }
}
